## ----options,echo=FALSE-----------------------------------------------
options(width=72)

## ----biocLite, eval=FALSE---------------------------------------------
#  source("https://bioconductor.org/biocLite.R")
#  biocLite("Discordant")

## ----initialize-------------------------------------------------------
library(discordant)

## ----runOutliers, eval=FALSE------------------------------------------
#  data(TCGA_Breast_miRNASeq)
#  mat.filtered <- splitMADOutlier(TCGA_Breast_miRNASeq,filter0 = TRUE, threshold = 4)

## ----createVectors----------------------------------------------------
data(TCGA_GBM_miRNA_microarray)
data(TCGA_GBM_transcript_microarray)
groups <- c(rep(1,10), rep(2,10))

#Within -Omics
wthn_vectors <- createVectors(TCGA_GBM_transcript_microarray, groups = groups)
#Between -Omics
btwn_vectors <- createVectors(TCGA_GBM_miRNA_microarray, TCGA_GBM_transcript_microarray, groups = groups)

## ----discordant-------------------------------------------------------
data(TCGA_GBM_miRNA_microarray)
data(TCGA_GBM_transcript_microarray)
groups <- c(rep(1,10), rep(2,10))

#Within -omics
wthn_vectors <- createVectors(TCGA_GBM_transcript_microarray, groups = groups)
wthn_result <- discordantRun(wthn_vectors$v1, wthn_vectors$v2, TCGA_GBM_transcript_microarray)
wthn_result$discordPPMatrix[1:4,1:4]
head(wthn_result$discordPPVector)
wthn_result$classMatrix[1:4,1:4]
head(wthn_result$classVector)
head(wthn_result$probMatrix)
wthn_result$loglik

# Between -omics
btwn_vectors <- createVectors(TCGA_GBM_miRNA_microarray, TCGA_GBM_transcript_microarray, groups = groups)
btwn_result <- discordantRun(btwn_vectors$v1, btwn_vectors$v2, TCGA_GBM_miRNA_microarray, TCGA_GBM_transcript_microarray)
btwn_result$discordPPMatrix[1:3,1:3]
head(btwn_result$discordPPVector)
btwn_result$classMatrix[1:3,1:3] 
btwn_result$classMatrix[1:3,1:3]
head(btwn_result$classVector)
head(btwn_result$probMatrix)
btwn_result$loglik

## ----microarrays------------------------------------------------------
data(TCGA_GBM_miRNA_microarray)
data(TCGA_GBM_transcript_microarray)
groups <- c(rep(1,10), rep(2,10))

#Within -Omics

wthn_vectors <- createVectors(TCGA_GBM_transcript_microarray, groups = groups)
wthn_result <- discordantRun(wthn_vectors$v1, wthn_vectors$v2, TCGA_GBM_transcript_microarray)

#Between -Omics

btwn_vectors <- createVectors(TCGA_GBM_miRNA_microarray, TCGA_GBM_transcript_microarray, groups = groups)
btwn_result <- discordantRun(btwn_vectors$v1, btwn_vectors$v2, TCGA_GBM_miRNA_microarray, TCGA_GBM_transcript_microarray)

